#include <jni.h>
#include <stdio.h>
#include "TestJNIString.h"

JNIEXPORT jstring JNICALL Java_TestJNIString_sayHello(JNIEnv *env, jobject thisObj, jstring inJNIStr) {
   // krok 1: Konwersja z JNI String (jstring) do C-String (char*)
   const char *inCStr = (*env)->GetStringUTFChars(env, inJNIStr, NULL);
   if (NULL == inCStr) return NULL;

   // Krok 2: Wykonaj zamierzone operacje
   printf("W C, przekazany w parametrze łańcuch to: %s\n", inCStr);
   (*env)->ReleaseStringUTFChars(env, inJNIStr, inCStr);  // zwolnij zasoby

   // Poproś użytkownika o podanie łańcucha znaków C-string
   char outCStr[128];
   printf("Podaj łańcuch znaków: ");
   scanf("%s", outCStr);    // nie więcej niż 127 znaków

   // Krok 3: Skonwertuj C-string (char*) na JNI String (jstring) i zwróć rezultat
   return (*env)->NewStringUTF(env, outCStr);
}
