#include <jni.h>
#include <iostream>
#include <string>
#include "TestJNIString.h"
using namespace std;

JNIEXPORT jstring JNICALL Java_TestJNIString_sayHello(JNIEnv *env, jobject thisObj, jstring inJNIStr) {
   // krok 1: Konwersja z JNI String (jstring) do C-String (char*)
   const char *inCStr = env->GetStringUTFChars(inJNIStr, NULL);
   if (NULL == inCStr) return NULL;

   // Krok 2: Wykonaj zamierzone operacje
   cout << "W C++, przekazany w parametrze łańcuch to: " << inCStr << endl;
   env->ReleaseStringUTFChars(inJNIStr, inCStr);  // zwolnij zasoby

   // Poproś użytkownika o podanie łańcucha znaków C-string
   string outCppStr;
   cout << "Podaj łańcuch znaków: ";
   cin >> outCppStr;

   // Krok 3: Skonwertuj C++ string na C-string (char*) a następnie na JNI String (jstring) i zwróć rezultat
   return env->NewStringUTF(outCppStr.c_str());
}
