#include <jni.h>
#include <stdio.h>
#include "TestJavaConstructor.h"

JNIEXPORT jobject JNICALL Java_TestJavaConstructor_getIntegerObject
          (JNIEnv *env, jobject thisObj, jint number) {
   // Pobierz referencję do klasy java.lang.Integer
   jclass cls = (*env)->FindClass(env, "java/lang/Integer");

   // Pobierz identyfikator konstruktora w powyższej klasie, który przyjmuje wartość int
   jmethodID midInit = (*env)->GetMethodID(env, cls, "<init>", "(I)V");
   if (NULL == midInit) return NULL;
   // Wywołaj konstruktor, który utworzy instancję obiektu powyższej klasy
   jobject newObj = (*env)->NewObject(env, cls, midInit, number);

   // Pobierz identyfikator metody toString a następnie go wywołaj w celu przetestowania
   // poprawności utworzonego obiektu
   jmethodID midToString = (*env)->GetMethodID(env, cls, "toString", "()Ljava/lang/String;");
   if (NULL == midToString) return NULL;
   jstring resultStr = (*env)->CallObjectMethod(env, newObj, midToString);
   const char *resultCStr = (*env)->GetStringUTFChars(env, resultStr, NULL);
   printf("In C: the number is %s\n", resultCStr);

   return newObj;
}
